GNU bug report logs - #29826
nondeterministic Broken pipe

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Alex Vong <alexvong1995@HIDDEN>; dated Sat, 23 Dec 2017 20:25:01 UTC; Maintainer for guix is bug-guix@HIDDEN.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 14 Feb 2018 12:21:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 14 07:21:58 2018
Received: from localhost ([127.0.0.1]:42208 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1elw4T-0001V0-Pj
	for submit <at> debbugs.gnu.org; Wed, 14 Feb 2018 07:21:57 -0500
Received: from mail-lf0-f47.google.com ([209.85.215.47]:45927)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <go.wigust@HIDDEN>) id 1elw4S-0001Un-7m
 for 29826 <at> debbugs.gnu.org; Wed, 14 Feb 2018 07:21:56 -0500
Received: by mail-lf0-f47.google.com with SMTP id x196so29138535lfd.12
 for <29826 <at> debbugs.gnu.org>; Wed, 14 Feb 2018 04:21:56 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=IoeS1I5CvEFOTH2mu7uGD+IqVXpyc4otbfO8UU1odqI=;
 b=Us8fcdfZCzs511JKmjNOinYmYKAY/fzaRuL6rlQWbrgC14v7viCs1L7iGI5YozlGjZ
 /ltztw2cKiaue02wX0fEbW3wgP/slTLuFLg7UCWk/5rkWAHTnIiy/SNQNQNrQ6obhigL
 DQEkd4NDfkP27FHJBvJGOchG0riv2rVl7FEimLiz3hkwD78E1qq8YbqvMLS7LrwrYzKM
 iX2EF8BysevJqIQRGh947Rx4mAP5v201CFYVC8sLir7bH1dSC9+2Qdz0YKOXjr0zrFJd
 GwNUB2G7rf9r4+iZvHxZ9lwZHYbv40pBktJ4RcHb0RZaPe06H1nDdtSxNd6Aat7hpPt0
 NIBA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=IoeS1I5CvEFOTH2mu7uGD+IqVXpyc4otbfO8UU1odqI=;
 b=XcwOkq3D8+IOfr1klB9OjnomMiC/y2PdIPkUCL3ByP1+UM/5aAlxf1pDAL+MrZ0yiY
 JnK1YjbXeRhFbxtNAgqUzRXQBbCxZq1UfcqUcMje5CdyHJ/oi6AtG8IqKS3jDM0n72Ey
 bndSl/y9XjuJ6og14y7b/Ws1M68nmKuhvM3fHPYOqnNljq7QCKUM0+W/ODyH4w3l8nY4
 TkBxhTg59VV40KRA0zRC9vrOUGoXdSjEBVO3b9kb84YAoZEparjmik200X1Z0Qtq2quO
 GDv4f7UTs2wEcAGTjC3X8BsHUyk8Jluwef73w9LjZa9hJ0FmgU3oPU8ftUkkIiSAdgHO
 5nYQ==
X-Gm-Message-State: APf1xPDS9jiOsjoNOgbVaTzwKT/vbmN+7nticZDCgAQd5GA9ZeUFkga7
 s9NzGffPAptRgvrgFrE/ZvfbHQ==
X-Google-Smtp-Source: AH8x225qpwQYPFm722qA497koYC0KK1mIS7gRCZiR9EjD5fEhIDqvRUQfRRwWh/UgWiFltbc7sPqXQ==
X-Received: by 10.46.21.75 with SMTP id 11mr3348169ljv.58.1518610909826;
 Wed, 14 Feb 2018 04:21:49 -0800 (PST)
Received: from magnolia (ppp78-37-133-175.pppoe.avangarddsl.ru.
 [78.37.133.175])
 by smtp.gmail.com with ESMTPSA id a72sm2017037ljf.92.2018.02.14.04.21.47
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Wed, 14 Feb 2018 04:21:48 -0800 (PST)
From: Oleg Pykhalov <go.wigust@HIDDEN>
To: Alex Vong <alexvong1995@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN>
Date: Wed, 14 Feb 2018 15:21:38 +0300
In-Reply-To: <874lohdwhb.fsf@HIDDEN> (Alex Vong's message of "Sun, 24 Dec
 2017 04:23:44 +0800")
Message-ID: <87a7wbiwx9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29826
Cc: 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hello Alex,

Alex Vong <alexvong1995@HIDDEN> writes:

> I get the following error when running ``guix --version | head -n 1''. I
> can get similar after replacing ``--version'' with ``--help''. Also, the
> error is nondeterministic. Any idea?
>
> $ LC_ALL=3DC guix --version | head -n 1
> guix (GNU Guix) 91213c384b62bc422896d39005efa922e4fa75f2

As a workaround =E2=80=98LC_ALL=3DC head -n 1 <(guix --version)=E2=80=99.

[=E2=80=A6]

Oleg.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEc+OyAXw1EaDPCmAPckbhHGm3lWkFAlqEKdIACgkQckbhHGm3
lWlqAw/8DWAoEjicStlsz/Qt+5D0WSVNtryqAEt5j2ZStKAdTdsOPiwc+XoGqD9H
thoGI7WP8NYySuifHBc9FvJo82FUNFyJ+jXsV/JQfqs7ZHAGDBmStHrPun1EG+IJ
VdL4L1+fdqihGv2w72h9lqkAqjUxEfeJu5aKISik/I4FizPYv71Ou44az7dGuOaj
QEUNZ5zwxHXCQ2EZH1+2NzsIgyxjfR3ZgViIPh0DCs0gXGpWiWi922nwKokvbiJ5
CjRPlzZDmJW3UJQwngTXw9tsleJlfXnXpp4+gQICrUvLzFy6aJPscjF/+ooBMHZ8
2gaYcN+rV57GutOh+IoLsWNJVuef5RGv0RASgrz/6MOVuK9SbdidgsrhYyKh5Saz
NPlFHSMyz9I629K/d5nzH6thr05bHd4EFyHJUHImWzwtXX2tFJ+IEhvdRgR5BGuw
ihgCQBkfLpiqHa2fZUdJjgcsvFsLuOERkKLkg4bAiNKYwmESnWB60XnB3i6ZfZJE
G7J3rQR0B9O9W1Gq75eB4IRseLNLIGYdbmnMbsv4snlko4Bm7+AdXxtR2xOZomBJ
Etqprdig1xdupwrkqtoUOSKOdn1eOJolUeVKh45pIdcC5gmZ6P8fui9+ksbtpuM1
iaHrBudjjyfq98Yn08OG/hyt+7ZR1eNeLOc3IgQQZKdoNq+Uv6E=
=/+a/
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 2 Jan 2018 22:17:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 02 17:17:16 2018
Received: from localhost ([127.0.0.1]:33561 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eWUs0-0000nE-6S
	for submit <at> debbugs.gnu.org; Tue, 02 Jan 2018 17:17:16 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:45218)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1eWUrx-0000n5-Kj
 for 29826 <at> debbugs.gnu.org; Tue, 02 Jan 2018 17:17:14 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 8C08A100FB;
 Tue,  2 Jan 2018 23:17:12 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id QnrfjStnTDLL; Tue,  2 Jan 2018 23:17:10 +0100 (CET)
Received: from ribbon (ADijon-655-1-96-177.w86-218.abo.wanadoo.fr
 [86.218.227.177])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 36FA1100F3;
 Tue,  2 Jan 2018 23:17:09 +0100 (CET)
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Mark H Weaver <mhw@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <87d133lqsb.fsf@HIDDEN>
 <87608uaorx.fsf@HIDDEN> <87k1x32on0.fsf@HIDDEN>
 <87inckxetr.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 13 =?utf-8?Q?Niv=C3=B4se?= an 226 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Tue, 02 Jan 2018 23:17:08 +0100
In-Reply-To: <87inckxetr.fsf@HIDDEN> (Mark H. Weaver's message of "Tue, 02
 Jan 2018 14:04:16 -0500")
Message-ID: <874lo3ykgr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 29826
Cc: Alex Vong <alexvong1995@HIDDEN>, 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Hello,

Mark H Weaver <mhw@HIDDEN> skribis:

> ludo@HIDDEN (Ludovic Court=C3=A8s) writes:

[...]

>> Not sure!  We specifically ignore EPIPE in cases where it matters, such
>> as for the output of =E2=80=98guix package --search=E2=80=99, =E2=80=98g=
uix package -A=E2=80=99, etc.
>> In other cases, it=E2=80=99s probably an error, so it=E2=80=99s worth re=
porting.
>>
>> WDYT?
>
> I see from the comment in (guix ui) where SIGPIPE is ignored, the
> rationale:
>
>   ;; Ignore SIGPIPE.  If the daemon closes the connection, we prefer to be
>   ;; notified via an EPIPE later.
>   (sigaction SIGPIPE SIG_IGN)
>
> Instead of unconditionally ignoring SIGPIPE here in (initialize-guix),
> it might be better to ignore SIGPIPE only if we open a connection to the
> daemon with the intent of mutating the store, and perhaps in some other
> cases where we're mutating information on disk (e.g. switching
> generations).  In those cases, we have a job to do that should ideally
> be completed regardless of whether anyone is still listening to our
> STDOUT.
>
> However, in many other cases, we don't mutate anything on disk, and our
> *only* job is printing information to the user, e.g. when showing
> version/usage information, the list of available packages, the list of
> generations, etc.  In those cases, I think it would be better to let
> SIGPIPE kill us, because there is no reason to keep the 'guix' process
> alive if its output is going nowhere.  These are also the cases where
> it's most useful to pipe 'guix' output into other commands.
>
> So, I think we should consider removing (sigaction SIGPIPE SIG_IGN) from
> (initialize-guix), and instead putting it in various other selected
> places.
>
> What do you think?

Why not.  An option would be to move (sigaction SIGPIPE SIG_IGN) to
=E2=80=98open-connection=E2=80=99, though that=E2=80=99s not following =E2=
=80=9Clibrary design best
practices.=E2=80=9D

If we do that, can we really remove the =E2=80=98leave-on-EPIPE=E2=80=99 us=
es that we
have in (guix scripts package) for instance?  At first sight they are in
=E2=80=98process-query=E2=80=99, which corresponds to operations that don=
=E2=80=99t rely on the
store, so that should be safe.

There are a few other uses of =E2=80=98leave-on-EPIPE=E2=80=99 that happen =
while the
store is opened (in =E2=80=98guix size=E2=80=99, =E2=80=98guix challenge=E2=
=80=99).  We=E2=80=99d have to keep
these.

Thoughts?

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 2 Jan 2018 19:04:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 02 14:04:48 2018
Received: from localhost ([127.0.0.1]:33438 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eWRrk-0004rR-9V
	for submit <at> debbugs.gnu.org; Tue, 02 Jan 2018 14:04:48 -0500
Received: from world.peace.net ([50.252.239.5]:44970)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mhw@HIDDEN>) id 1eWRri-0004rF-V5
 for 29826 <at> debbugs.gnu.org; Tue, 02 Jan 2018 14:04:47 -0500
Received: from pool-72-93-27-221.bstnma.east.verizon.net ([72.93.27.221]
 helo=jojen)
 by world.peace.net with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <mhw@HIDDEN>)
 id 1eWRrc-0005Fo-Ix; Tue, 02 Jan 2018 14:04:40 -0500
From: Mark H Weaver <mhw@HIDDEN>
To: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <87d133lqsb.fsf@HIDDEN>
 <87608uaorx.fsf@HIDDEN> <87k1x32on0.fsf@HIDDEN>
Date: Tue, 02 Jan 2018 14:04:16 -0500
In-Reply-To: <87k1x32on0.fsf@HIDDEN> ("Ludovic
 \=\?utf-8\?Q\?Court\=C3\=A8s\=22'\?\=
 \=\?utf-8\?Q\?s\?\= message of "Sun, 31 Dec 2017 11:11:15 +0100")
Message-ID: <87inckxetr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 29826
Cc: Alex Vong <alexvong1995@HIDDEN>, 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Hi,

ludo@HIDDEN (Ludovic Court=C3=A8s) writes:

> Alex Vong <alexvong1995@HIDDEN> skribis:
>
>> Mark H Weaver <mhw@HIDDEN> writes:
>>
>>> Alex Vong <alexvong1995@HIDDEN> writes:
>>>
>>>> I get the following error when running ``guix --version | head -n 1''.=
 I
>>>> can get similar after replacing ``--version'' with ``--help''. Also, t=
he
>>>> error is nondeterministic. Any idea?
>>>
>>> Attempts to write to a pipe that has already been closed on the other
>>> end results in EPIPE.  From the write(2) man page:
>>>
>>>   EPIPE fd is connected to a pipe or socket whose reading end is closed.
>>>         When this happens the writing process will also receive a
>>>         SIGPIPE signal.  (Thus, the write return value is seen only if
>>>         the program catches, blocks or ignores this signal.)
>>>
>>> In this case, there's a race condition.  The result depends on whether
>>> "head -n 1" closes its end of the pipe before or after "guix --version"
>>> is finished writing all of its output.  If "head -n 1" closes the pipe
>>> first, then "guix --version" will receive EPIPE while attempting to
>>> write to it.
>>>
>>> What normally happens is that the sending process receives SIGPIPE,
>>> which simply causes it to exit prematurely without ever receiving this
>>> error.  However, since Guix arranges to ignore SIGPIPE in
>>> 'initialize-guix' in guix/ui.scm, we receive EPIPE.
>>>
>>> That's what's happening here.  I'll need to think on how best to fix it.
>>>
>>>      Regards,
>>>        Mark
>>
>> Nice explaination as always! I forget to mention that I reported a bug
>> of similar flavour before <http://bugs.gnu.org/27017>. I agree that
>> thought is needed to fix all instances of this type of bug.
>
> Not sure!  We specifically ignore EPIPE in cases where it matters, such
> as for the output of =E2=80=98guix package --search=E2=80=99, =E2=80=98gu=
ix package -A=E2=80=99, etc.
> In other cases, it=E2=80=99s probably an error, so it=E2=80=99s worth rep=
orting.
>
> WDYT?

I see from the comment in (guix ui) where SIGPIPE is ignored, the
rationale:

  ;; Ignore SIGPIPE.  If the daemon closes the connection, we prefer to be
  ;; notified via an EPIPE later.
  (sigaction SIGPIPE SIG_IGN)

Instead of unconditionally ignoring SIGPIPE here in (initialize-guix),
it might be better to ignore SIGPIPE only if we open a connection to the
daemon with the intent of mutating the store, and perhaps in some other
cases where we're mutating information on disk (e.g. switching
generations).  In those cases, we have a job to do that should ideally
be completed regardless of whether anyone is still listening to our
STDOUT.

However, in many other cases, we don't mutate anything on disk, and our
*only* job is printing information to the user, e.g. when showing
version/usage information, the list of available packages, the list of
generations, etc.  In those cases, I think it would be better to let
SIGPIPE kill us, because there is no reason to keep the 'guix' process
alive if its output is going nowhere.  These are also the cases where
it's most useful to pipe 'guix' output into other commands.

So, I think we should consider removing (sigaction SIGPIPE SIG_IGN) from
(initialize-guix), and instead putting it in various other selected
places.

What do you think?

      Mark




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 2 Jan 2018 12:08:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 02 07:08:06 2018
Received: from localhost ([127.0.0.1]:60549 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eWLMU-0001dz-8I
	for submit <at> debbugs.gnu.org; Tue, 02 Jan 2018 07:08:06 -0500
Received: from mail-pl0-f47.google.com ([209.85.160.47]:32848)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alexvong1995@HIDDEN>) id 1eWLMS-0001dV-Hi
 for 29826 <at> debbugs.gnu.org; Tue, 02 Jan 2018 07:08:04 -0500
Received: by mail-pl0-f47.google.com with SMTP id 1so27075370plv.0
 for <29826 <at> debbugs.gnu.org>; Tue, 02 Jan 2018 04:08:04 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=ZkA9GGJ+XYiivYoee6WxuoSxh8QdwXxsIr6PgfUkyck=;
 b=jn4mDWJGA0Kj3KhU+6zbaKz1bwYMsrPB3Oeag+cp5Gh5SP8TP/DrjwPJLmsBScFICh
 0y7TPN3lL7ACdqhPGJEII15pgJbkgrUW097keHo9vuE1qwD5qw3EPALKiTjNU7tjliSU
 QPknEUre2jNWbgFv6KgntVy9J1kB+vx/9C84yzReDP+eUSo07nBQdoUc7SYkoTZ4XIfZ
 knsTh8zednVn0x9Xrfb/2v5B0ZGJQiUIrGguYaAXEKLtFXycwSDdd6vxixjd8RQA+njz
 1fckg+4WuEh30OejnymiHnAZDBrmJzxUcvDwBnuL7vPzw7JmiORe+49mCuke0gmMikvI
 Q6xg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=ZkA9GGJ+XYiivYoee6WxuoSxh8QdwXxsIr6PgfUkyck=;
 b=obrb4d7KxGrs101NZ4AdMQusuzFFkFhUQBVPKkvvu6gwetzaHfGlkRbMF5eNbp2teN
 MWMY3Ofpl7gOQuBFir36O3OF6CSwgnrxgvvKgOvcvnoDQcPHksEwuP25VHCY7lRr71Qd
 Wd2ZXjWynsxxmzYGLcnWabjrceDfWDWClmM4AcGdpgS72g2MXy11TFJE/3ec9UftNI6Q
 ZWG/7vug4c2hQG1QjS+kILbTCFwdLegmEedm2H2nmjtd00r98Rh+kypEw8+wcHJsaWGV
 HAVq2EZI3YdmpbmchBB9wcEsuav6CTArhAsbh2rznCez0I9yYbOXd0mJIwwzPrQPe/fL
 TjEg==
X-Gm-Message-State: AKGB3mLpQ7vb8kWy7X8eb5k3iSikuNmW7LYlB6OsY1N45DtuVHLKmlJD
 Krpkot7G9pl6QWZI6i0bvBY=
X-Google-Smtp-Source: ACJfBovc25JL5cLkV5Xp8xuPU6yJHOlYoaYn7+IhYEAlCKJM/GMiskvpytyjJ73FPDC8soa+8kIJiw==
X-Received: by 10.84.232.6 with SMTP id h6mr44465030plk.263.1514894878711;
 Tue, 02 Jan 2018 04:07:58 -0800 (PST)
Received: from debian (n219073080082.netvigator.com. [219.73.80.82])
 by smtp.gmail.com with ESMTPSA id o88sm89099228pfj.175.2018.01.02.04.07.56
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Tue, 02 Jan 2018 04:07:57 -0800 (PST)
From: Alex Vong <alexvong1995@HIDDEN>
To: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <87d133lqsb.fsf@HIDDEN>
 <87608uaorx.fsf@HIDDEN> <87k1x32on0.fsf@HIDDEN>
Date: Tue, 02 Jan 2018 20:07:41 +0800
In-Reply-To: <87k1x32on0.fsf@HIDDEN> ("Ludovic
 \=\?utf-8\?Q\?Court\=C3\=A8s\=22'\?\=
 \=\?utf-8\?Q\?s\?\= message of "Sun, 31 Dec 2017 11:11:15 +0100")
Message-ID: <87po6s31ma.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 29826
Cc: Mark H Weaver <mhw@HIDDEN>, 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hello,

ludo@HIDDEN (Ludovic Court=C3=A8s) writes:

> Hi,
>
> Alex Vong <alexvong1995@HIDDEN> skribis:
>
>> Mark H Weaver <mhw@HIDDEN> writes:
>>
>>> Alex Vong <alexvong1995@HIDDEN> writes:
>>>
>>>> I get the following error when running ``guix --version | head -n 1''.=
 I
>>>> can get similar after replacing ``--version'' with ``--help''. Also, t=
he
>>>> error is nondeterministic. Any idea?
>>>
>>> Attempts to write to a pipe that has already been closed on the other
>>> end results in EPIPE.  From the write(2) man page:
>>>
>>>   EPIPE fd is connected to a pipe or socket whose reading end is closed.
>>>         When this happens the writing process will also receive a
>>>         SIGPIPE signal.  (Thus, the write return value is seen only if
>>>         the program catches, blocks or ignores this signal.)
>>>
>>> In this case, there's a race condition.  The result depends on whether
>>> "head -n 1" closes its end of the pipe before or after "guix --version"
>>> is finished writing all of its output.  If "head -n 1" closes the pipe
>>> first, then "guix --version" will receive EPIPE while attempting to
>>> write to it.
>>>
>>> What normally happens is that the sending process receives SIGPIPE,
>>> which simply causes it to exit prematurely without ever receiving this
>>> error.  However, since Guix arranges to ignore SIGPIPE in
>>> 'initialize-guix' in guix/ui.scm, we receive EPIPE.
>>>
>>> That's what's happening here.  I'll need to think on how best to fix it.
>>>
>>>      Regards,
>>>        Mark
>>
>> Nice explaination as always! I forget to mention that I reported a bug
>> of similar flavour before <http://bugs.gnu.org/27017>. I agree that
>> thought is needed to fix all instances of this type of bug.
>
> Not sure!  We specifically ignore EPIPE in cases where it matters, such
> as for the output of =E2=80=98guix package --search=E2=80=99, =E2=80=98gu=
ix package -A=E2=80=99, etc.
> In other cases, it=E2=80=99s probably an error, so it=E2=80=99s worth rep=
orting.
>
> WDYT?
>
> In C such errors are usually ignored, which is nice for shell hackery
> but otherwise not so great.
>
> Ludo=E2=80=99.

Do you mean there are use-cases where the EPIPE signal really means
there is an error? What I think is that the 'guix' command is meant to
be used in a shell script, so it should work nice with other shell tools
in a pipe, including head & tail. But maybe it will cause other problems
if we always ignore EPIPE, I don't know...=20

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEdZDkzSn0Cycogr9IxYq4eRf1Ea4FAlpLdg4ACgkQxYq4eRf1
Ea7vRw/7BGm0Jbf9jIVP4Uham/SKiMXmo2jRjRpXCeYcafNjP/Z1L0Mo7tPgC3nv
/vZK8L8WkIRkeGfhjYUrkXIkrBXR96KAtNshnMHiqsVfeWsXtvUbB8lS8XCIk+rm
fLgwtrUNZZNdNxGbnY1wfr6nkE/Ziq4FWNOr8ww+fUIWVK0jLtWDoTbm/7SYaupd
mTUgfyH58yjhZCTCBlRutKxCyQZotubyMhI2KStlL0F0QwE4AuvVFvSQqevgrhon
Emec7X896X+NIh9rLAJW6D9GbmzMYqLdriUmKKFDL8bldZgYAN1ikZXJkOboSQUz
2lEHcAHBSXobzvxd6u8bqV15FcpY8vkZTR0F5DO11VKWcErOnSo6Kr8+MXNDDQTb
Ii5YIY+etUcc/M6CSegcwJn89lw6XbkxY9OoyhkTf8WaDB+d8ve+U1pYRKwEolo2
mTfnv+mJ3sVb+l4KRZrrITBA/pAsKn94L+tH3wYQiIYZmvpNPiiZdqESf3DwUijR
ql9I6C6IJcaHXrVRQCgQvq/uCVPWAlyxVi42NIQ3OZYdFHe7EUbjhmQH7FLf417T
OUuEeg5IRJteSSBaGedox9ZQ6JvTEqSmc9pXP4p6HAJlGC01oA0KaBSgJ3Mt2fKx
o46YFYZ+XCb8NAvSebtxZJ1/H/ct1S2VuFFJS1ki3GFmRZPP1Vw=
=JkIe
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 31 Dec 2017 10:11:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 31 05:11:26 2017
Received: from localhost ([127.0.0.1]:58375 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eVaaU-0005k2-3Y
	for submit <at> debbugs.gnu.org; Sun, 31 Dec 2017 05:11:26 -0500
Received: from [141.255.128.1] (port=44749 helo=hera.aquilenet.fr)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1eVaaS-0005jt-KM
 for 29826 <at> debbugs.gnu.org; Sun, 31 Dec 2017 05:11:25 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 9AF83107A0;
 Sun, 31 Dec 2017 11:11:23 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id ALj7HR6_NkDH; Sun, 31 Dec 2017 11:11:22 +0100 (CET)
Received: from ribbon (ADijon-655-1-10-136.w109-221.abo.wanadoo.fr
 [109.221.233.136])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id BF3B41078F;
 Sun, 31 Dec 2017 11:11:17 +0100 (CET)
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Alex Vong <alexvong1995@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <87d133lqsb.fsf@HIDDEN>
 <87608uaorx.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 11 =?utf-8?Q?Niv=C3=B4se?= an 226 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sun, 31 Dec 2017 11:11:15 +0100
In-Reply-To: <87608uaorx.fsf@HIDDEN> (Alex Vong's message of "Mon, 25 Dec
 2017 22:02:58 +0800")
Message-ID: <87k1x32on0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi,
 Alex Vong <alexvong1995@HIDDEN> skribis: > Mark H Weaver
 <mhw@HIDDEN> writes: > >> Alex Vong <alexvong1995@HIDDEN> writes:
 >> >>> I get the following error when running ``guix --version | head -n 1''.
 I >>> can get similar after replacing ``--version'' with ``--help''. Also,
 the >>> error is nondeterministic. Any idea? >> >> Attempts to write to a
 pipe that has already been closed on the other >> end results in EPIPE. From
 the write(2) man page: >> >> EPIPE fd is connected to a pipe or socket whose
 reading end is closed. >> When this happens the writing process will also
 receive a >> SIGPIPE signal. (Thus, the write return value is seen only if
 >> the program catches, blocks or ignores this signal.) >> >> In this case,
 there's a race condition. The result depends on whether >> "head -n 1" closes
 its end of the pipe before or after "guix --version" >> is finished writing
 all of its output. If "head -n 1" closes the pipe >> first,
 then "guix --version"
 will receive EPIPE while attempting to >> write to it. >> >> What normally
 happens is that the sending process receives SIGPIPE, >> which simply causes
 it to exit prematurely without ever receiving this >> error. However, since
 Guix arranges to ignore SIGPIPE in >> 'initialize-guix' in guix/ui.scm, we
 receive EPIPE. >> >> That's what's happening here. I'll need to think on
 how best to fix it. >> >> Regards, >> Mark > > Nice explaination as always!
 I forget to mention that I reported a bug > of similar flavour before
 <http://bugs.gnu.org/27017>.
 I agree that > thought is needed to fix all instances of this type of bug.
 [...] Content analysis details:   (2.2 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 0.0 SPF_HELO_FAIL          SPF: HELO does not match SPF record (fail)
 [SPF failed: Please see http://www.openspf.org/Why?s=helo; id=hera.aquilenet.fr;
 ip=141.255.128.1; r=debbugs.gnu.org]
 1.3 RDNS_NONE Delivered to internal network by a host with no rDNS
X-Debbugs-Envelope-To: 29826
Cc: Mark H Weaver <mhw@HIDDEN>, 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi, Alex Vong <alexvong1995@HIDDEN> skribis: > Mark H Weaver
    <mhw@HIDDEN> writes: > >> Alex Vong <alexvong1995@HIDDEN> writes:
   >> >>> I get the following error when running ``guix --version | head -n 1''.
    I >>> can get similar after replacing ``--version'' with ``--help''. Also,
    the >>> error is nondeterministic. Any idea? >> >> Attempts to write to a
    pipe that has already been closed on the other >> end results in EPIPE. From
    the write(2) man page: >> >> EPIPE fd is connected to a pipe or socket whose
    reading end is closed. >> When this happens the writing process will also
    receive a >> SIGPIPE signal. (Thus, the write return value is seen only if
    >> the program catches, blocks or ignores this signal.) >> >> In this case,
    there's a race condition. The result depends on whether >> "head -n 1" closes
    its end of the pipe before or after "guix --version" >> is finished writing
    all of its output. If "head -n 1" closes the pipe >> first, then "guix --version"
    will receive EPIPE while attempting to >> write to it. >> >> What normally
    happens is that the sending process receives SIGPIPE, >> which simply causes
    it to exit prematurely without ever receiving this >> error. However, since
    Guix arranges to ignore SIGPIPE in >> 'initialize-guix' in guix/ui.scm, we
    receive EPIPE. >> >> That's what's happening here. I'll need to think on
   how best to fix it. >> >> Regards, >> Mark > > Nice explaination as always!
    I forget to mention that I reported a bug > of similar flavour before <http://bugs.gnu.org/27017>.
    I agree that > thought is needed to fix all instances of this type of bug.
    [...] 
 
 Content analysis details:   (2.2 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.0 SPF_HELO_FAIL          SPF: HELO does not match SPF record (fail)
 [SPF failed: Please see http://www.openspf.org/Why?s=helo;id=hera.aquilenet.fr;ip=141.255.128.1;r=debbugs.gnu.org]
  1.3 RDNS_NONE              Delivered to internal network by a host with no rDNS

Hi,

Alex Vong <alexvong1995@HIDDEN> skribis:

> Mark H Weaver <mhw@HIDDEN> writes:
>
>> Alex Vong <alexvong1995@HIDDEN> writes:
>>
>>> I get the following error when running ``guix --version | head -n 1''. I
>>> can get similar after replacing ``--version'' with ``--help''. Also, the
>>> error is nondeterministic. Any idea?
>>
>> Attempts to write to a pipe that has already been closed on the other
>> end results in EPIPE.  From the write(2) man page:
>>
>>   EPIPE fd is connected to a pipe or socket whose reading end is closed.
>>         When this happens the writing process will also receive a
>>         SIGPIPE signal.  (Thus, the write return value is seen only if
>>         the program catches, blocks or ignores this signal.)
>>
>> In this case, there's a race condition.  The result depends on whether
>> "head -n 1" closes its end of the pipe before or after "guix --version"
>> is finished writing all of its output.  If "head -n 1" closes the pipe
>> first, then "guix --version" will receive EPIPE while attempting to
>> write to it.
>>
>> What normally happens is that the sending process receives SIGPIPE,
>> which simply causes it to exit prematurely without ever receiving this
>> error.  However, since Guix arranges to ignore SIGPIPE in
>> 'initialize-guix' in guix/ui.scm, we receive EPIPE.
>>
>> That's what's happening here.  I'll need to think on how best to fix it.
>>
>>      Regards,
>>        Mark
>
> Nice explaination as always! I forget to mention that I reported a bug
> of similar flavour before <http://bugs.gnu.org/27017>. I agree that
> thought is needed to fix all instances of this type of bug.

Not sure!  We specifically ignore EPIPE in cases where it matters, such
as for the output of =E2=80=98guix package --search=E2=80=99, =E2=80=98guix=
 package -A=E2=80=99, etc.
In other cases, it=E2=80=99s probably an error, so it=E2=80=99s worth repor=
ting.

WDYT?

In C such errors are usually ignored, which is nice for shell hackery
but otherwise not so great.

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 25 Dec 2017 14:03:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 25 09:03:26 2017
Received: from localhost ([127.0.0.1]:51233 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eTTLg-0002Pd-AG
	for submit <at> debbugs.gnu.org; Mon, 25 Dec 2017 09:03:25 -0500
Received: from mail-pl0-f45.google.com ([209.85.160.45]:36654)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alexvong1995@HIDDEN>) id 1eTTLd-0002PO-Hf
 for 29826 <at> debbugs.gnu.org; Mon, 25 Dec 2017 09:03:23 -0500
Received: by mail-pl0-f45.google.com with SMTP id b12so16706144plm.3
 for <29826 <at> debbugs.gnu.org>; Mon, 25 Dec 2017 06:03:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=LVzhZio+2xWzfs9+JFQ/XOkZlld9jft1WsYW/MPgi8c=;
 b=TRIn4FseBQ1arBE0gNWGk0h3CPGhdYlfNYBBY65avsXkM/O6gLuF9/x5ST08CrK5Pv
 Fhi7ImoIIu6jAnJYZKkjCY82e/KuKFoWB/YJRzCVIV9EoA+QLKueiFuipnW4sGoJLNav
 L4ueo1uDEZsVAT4rJWYpaDTjRU1Z43epFMvN46JYzedb6gfv6U90QGGU8YXQ2bt4+gL1
 ISGl5E1GqUhgibW5m247bQkqNAAxEj0SAb7XVjb8rleDVzCfqOFWn8zvk+pP/Sa1msDv
 z7uaWd/fGPpdIURDyqEpX3fT9zYaSeSf5fADM1VTnMuWmq+ZMO9hgB26L0DUhSFOtfkQ
 q/Rw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=LVzhZio+2xWzfs9+JFQ/XOkZlld9jft1WsYW/MPgi8c=;
 b=HELs8VsYM9VGYCbZiG0PEpBwhI4eWcepS41w/83Kf4JVuG83bisH3i0HhgMfwntYO4
 zsnQCjiDPO9Op1+50CufUFsWW/ZlrfqdDLfIlqdDmmGru9HXCInoDkzMcr2GTxmW5gHy
 0nJPTocEmVLPMX0bhOkxSVKk0sXDFVPZK/1W/65nowFvxk7p154r4s5gSMGXYsY2m+zC
 rxmQa9n4/plnve50fI/zWqePMCszdFw3i1NE9Fg5+Rd2XehQjA8Y7SZMYnyyfYArk1wo
 IiORFbuPeVpbjrqKyNweE03TvXYeVUOb5gmjBp1knpXFDXyzSkmiFgAhvo5iEb9u9tpO
 Kt2A==
X-Gm-Message-State: AKGB3mJqKMKw5zHJbcdBmBB1zxaeBTiicXhiIiFI7ccHxPi5orQy9RpM
 gwzIEaCl7goM6K77GDgKMMQ=
X-Google-Smtp-Source: ACJfBotiNwT5gYyL+zS3/CHj4yFjU5r/S/vZbrmADChfZk5/m60/amb3zxXbHXQErN0eeQqQubAt1g==
X-Received: by 10.84.216.26 with SMTP id m26mr22297902pli.432.1514210595587;
 Mon, 25 Dec 2017 06:03:15 -0800 (PST)
Received: from debian (42-98-181-252.static.netvigator.com. [42.98.181.252])
 by smtp.gmail.com with ESMTPSA id o10sm45633103pgq.89.2017.12.25.06.03.13
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Mon, 25 Dec 2017 06:03:14 -0800 (PST)
From: Alex Vong <alexvong1995@HIDDEN>
To: Mark H Weaver <mhw@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <87d133lqsb.fsf@HIDDEN>
Date: Mon, 25 Dec 2017 22:02:58 +0800
In-Reply-To: <87d133lqsb.fsf@HIDDEN> (Mark H. Weaver's message of "Sun, 24
 Dec 2017 17:11:48 -0500")
Message-ID: <87608uaorx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 29826
Cc: 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

--=-=-=
Content-Type: text/plain

Mark H Weaver <mhw@HIDDEN> writes:

> Alex Vong <alexvong1995@HIDDEN> writes:
>
>> I get the following error when running ``guix --version | head -n 1''. I
>> can get similar after replacing ``--version'' with ``--help''. Also, the
>> error is nondeterministic. Any idea?
>
> Attempts to write to a pipe that has already been closed on the other
> end results in EPIPE.  From the write(2) man page:
>
>   EPIPE fd is connected to a pipe or socket whose reading end is closed.
>         When this happens the writing process will also receive a
>         SIGPIPE signal.  (Thus, the write return value is seen only if
>         the program catches, blocks or ignores this signal.)
>
> In this case, there's a race condition.  The result depends on whether
> "head -n 1" closes its end of the pipe before or after "guix --version"
> is finished writing all of its output.  If "head -n 1" closes the pipe
> first, then "guix --version" will receive EPIPE while attempting to
> write to it.
>
> What normally happens is that the sending process receives SIGPIPE,
> which simply causes it to exit prematurely without ever receiving this
> error.  However, since Guix arranges to ignore SIGPIPE in
> 'initialize-guix' in guix/ui.scm, we receive EPIPE.
>
> That's what's happening here.  I'll need to think on how best to fix it.
>
>      Regards,
>        Mark

Nice explaination as always! I forget to mention that I reported a bug
of similar flavour before <http://bugs.gnu.org/27017>. I agree that
thought is needed to fix all instances of this type of bug.

Cheers,
Alex

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEdZDkzSn0Cycogr9IxYq4eRf1Ea4FAlpBBRMACgkQxYq4eRf1
Ea7WKBAAq2tmAVBLOBX36icO3f8qb+9YsUvhrilqbLCa00uLCyUyN7PLp2vvlwPu
U5Jo7cXw3OgifmqplbIiaVvyhJQwA2Rvlzfyw3Xi05z2NNX7dOOFA0LBLo3+ieE8
EUugVPbIJQJRTj1yFBQq56w+f62Ze95MFhn6efmHqAvCDjP6eG0QNyxq5P/Q8R3A
7p8LACieqz9xYQsKk7PVLDXxsCFiF3RaVB+hOZa6d7aYBCXejvQvBVSkNsJSd6hV
SC7sm7PX96UA6I4mue3jVFV7Wv/HQMYn9uaTFfs8OLI+3nwbOvhvhJrgyGcamuep
WPG9Ghko4RUbm7/AVzwZ2C2I/o5z4wPEaDfmLqhH0NXx3SJu0htMw2as8lys9/LF
JfunT5pmPtZGC8jLMUMz2kf+mJhGsYuhmNsCbC9QXQD8OuzO8XrZuWHt+blmRt8C
uQjUodrqXDFz5ZfqFMuk/MevikR6oxQ7xO0RGYGuqj8Nyju9+Y+V7DHgffG0RVi3
LdvYv5PEyzeS6xbM4gsjKpB+ExDcgWIU+iooNoGA7gZs58vXvqOHvnBtuhU3fY2N
YQgnjLp4NLvqRulDQ7JobxsPfelzqqQ1OZNz/EtJBsl1yGz6kndsUuogtcPblKkD
uyLuj+IeNxy0CnFkVKMEuZgI8v+Kt9tKOXsuuBiFuIBFpH4wOgA=
=DDTi
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 24 Dec 2017 22:12:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 24 17:12:09 2017
Received: from localhost ([127.0.0.1]:51004 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eTEV7-00027M-6d
	for submit <at> debbugs.gnu.org; Sun, 24 Dec 2017 17:12:09 -0500
Received: from world.peace.net ([50.252.239.5]:53306)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mhw@HIDDEN>) id 1eTEV4-00026p-Sl
 for 29826 <at> debbugs.gnu.org; Sun, 24 Dec 2017 17:12:07 -0500
Received: from [10.1.10.104] (helo=jojen)
 by world.peace.net with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <mhw@HIDDEN>)
 id 1eTEUz-0004vU-9s; Sun, 24 Dec 2017 17:12:01 -0500
From: Mark H Weaver <mhw@HIDDEN>
To: Alex Vong <alexvong1995@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN>
Date: Sun, 24 Dec 2017 17:11:48 -0500
In-Reply-To: <874lohdwhb.fsf@HIDDEN> (Alex Vong's message of "Sun, 24 Dec
 2017 04:23:44 +0800")
Message-ID: <87d133lqsb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 29826
Cc: 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Alex Vong <alexvong1995@HIDDEN> writes:

> I get the following error when running ``guix --version | head -n 1''. I
> can get similar after replacing ``--version'' with ``--help''. Also, the
> error is nondeterministic. Any idea?

Attempts to write to a pipe that has already been closed on the other
end results in EPIPE.  From the write(2) man page:

  EPIPE fd is connected to a pipe or socket whose reading end is closed.
        When this happens the writing process will also receive a
        SIGPIPE signal.  (Thus, the write return value is seen only if
        the program catches, blocks or ignores this signal.)

In this case, there's a race condition.  The result depends on whether
"head -n 1" closes its end of the pipe before or after "guix --version"
is finished writing all of its output.  If "head -n 1" closes the pipe
first, then "guix --version" will receive EPIPE while attempting to
write to it.

What normally happens is that the sending process receives SIGPIPE,
which simply causes it to exit prematurely without ever receiving this
error.  However, since Guix arranges to ignore SIGPIPE in
'initialize-guix' in guix/ui.scm, we receive EPIPE.

That's what's happening here.  I'll need to think on how best to fix it.

     Regards,
       Mark




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 24 Dec 2017 08:38:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 24 03:38:20 2017
Received: from localhost ([127.0.0.1]:49896 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eT1nX-0004x9-Nd
	for submit <at> debbugs.gnu.org; Sun, 24 Dec 2017 03:38:20 -0500
Received: from mail-pl0-f42.google.com ([209.85.160.42]:33068)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alexvong1995@HIDDEN>) id 1eT1nV-0004ww-3O
 for 29826 <at> debbugs.gnu.org; Sun, 24 Dec 2017 03:38:17 -0500
Received: by mail-pl0-f42.google.com with SMTP id 1so13867363plv.0
 for <29826 <at> debbugs.gnu.org>; Sun, 24 Dec 2017 00:38:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=9FcFMcbr97heKFwvD4+32+JTkKVIX4tpgoCjA6/qEYk=;
 b=aGsWXrU76iBtcJ/EkyWeBGoGyRtn6pTI9ZsAcar0SoPsBZsH4qL96o3iGM54EWkg8w
 7P5kZ0ullxCvgtj0Jq+LcljwkezbLK4TA2jIRdf0HrH6FJOGO2PiRNp3RcJXWjOj8hBG
 wN2yoNVLFM4URD9DoThofJBXazi0GJ7fQsdt2A9mcZK2TP7cSphBy82aIRKg1viQr6aC
 Zc+XWc4gJve6XDZdyuNYSnhDLV6XaNXwDwwJ7CmRX0ZQ3JDHGdP6GB5abTq2q6Ng/HQd
 W8ffBJmoQ4QiJ5nO/o04PlzSZYNdcHJVVvYFlDz2mc2KUtRWetd/WvnMT67xYfyDekKh
 ZDEg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=9FcFMcbr97heKFwvD4+32+JTkKVIX4tpgoCjA6/qEYk=;
 b=cGhMZSSfg+/T5iqHWsbzJqWyyAbjbTNKV5rQf0m/7dmhfJbnS5uz59ou2j8Z3+dEa+
 6hzqw+WP9SIlfWeUdKApSHvoo6zZNkRTXqf4YsoOYAJaedGyy/Puw0ZimGwvgZkVJ4mP
 q78Cb/qzrBIreKOiQYCB+2UmeQhgJAhbWDGwZSIjlTMEwGaQaMmQ+bC+ZS45qJplmdoA
 ZtAx4RGPpFnSxGFgM7ciMJZf30Qp1FGJaoIiG7+4ZW3ozor2HHwVfWw217kBwSxxQhvI
 YZzzpxPOvUcnRl4pz/9pXplKpsiyLwrVkYGPeuddHzMzPfQGyMlFQqT6wSsy63XYKZ9A
 1wDw==
X-Gm-Message-State: AKGB3mJn9GtuvvmvmMtqr0d9K3WUT+ZjvPwttVbd0ovDojH56afoRScT
 HtDuZbhlkRbeNBV6Nd2avk8=
X-Google-Smtp-Source: ACJfBosnvhzCZ/wRz5DVO2qcb56fvglQvJRxJ3pngZgq9xBNyj01TEd+wInFakRF7qwt0/NHBdFs7g==
X-Received: by 10.159.244.12 with SMTP id x12mr19773383plr.312.1514104691222; 
 Sun, 24 Dec 2017 00:38:11 -0800 (PST)
Received: from debian (1-64-81-074.static.netvigator.com. [1.64.81.74])
 by smtp.gmail.com with ESMTPSA id h69sm52684307pfk.166.2017.12.24.00.38.09
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 24 Dec 2017 00:38:10 -0800 (PST)
From: Alex Vong <alexvong1995@HIDDEN>
To: Andreas Enge <andreas@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
References: <874lohdwhb.fsf@HIDDEN> <20171223204828.GA3290@jurong>
Date: Sun, 24 Dec 2017 16:37:53 +0800
In-Reply-To: <20171223204828.GA3290@jurong> (Andreas Enge's message of "Sat,
 23 Dec 2017 21:48:28 +0100")
Message-ID: <87zi68cyhq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 29826
Cc: 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

--=-=-=
Content-Type: text/plain

Andreas Enge <andreas@HIDDEN> writes:

> On Sun, Dec 24, 2017 at 04:23:44AM +0800, Alex Vong wrote:
>> ERROR: In procedure display:
>> ERROR: In procedure scm_flush: Broken pipe
>
> Interesting! I get a different error message:
>
> ERROR: In procedure display:
> In procedure fport_write: Broken pipe
>
> Andreas

Hmm... This may due to the fact I am using Guile 2.0 instead of 2.2

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEdZDkzSn0Cycogr9IxYq4eRf1Ea4FAlo/Z2IACgkQxYq4eRf1
Ea5Acg/+ImxYM3S7Gep4IFLhuOolvQeaR+NOjZ5sUcNuYN2LdGID/Bg4ZNcinjyp
4JeCgF5uk0CCOcJhbQlGe+nnvbvjRo0vryIglGNukYi5FUV/N1nzmkehcmaADGin
BHwVSg4PS2wm7U16b/Yy/rmAerbcwngjlU8/+vwqIGijoifroV09cwk0ohoqiNVM
i1D1Td5tkvWQDJsEJJ8tU1KRzGlKwCheUQEjK4bpEgONgg59h9QgBBdac356z8yv
X2EjZ+/Aly+5K4MnHSSqitY1rEukakBRw7qeehhM0FoSmxmbrXFhXi7cqx+fHzGt
URVVw1XKeqGzkY1cyu+6j5BqslvwzkQ6vTkBZ32c0CZTLEuoohHCWaNTLCM2t7K5
q4oFiAVx6WQ6V5X4wLdrrsIDolFOUGzWuEpju2POI526cPeGmnafs1lUP+kzo9z4
7RjMo44YQMdvRs2FGNmKbKpAY+/fBm7sPR0CbDnNB5ZL+JftB2NbU9iVq7Tpmr5/
ek6QOf80knfFKzMCL9/kKjc8TDpYVGPrGZ1Rplvp1zzQYW0j8cyiJ2NdH+29+gH6
N59Wq/Z81x7rJiOxjJvBiPqjMp32MQfLKGVu8FgZqSl99mg0itGW1g57dL3KhNfA
QVnJQspfaHm7bGzagppJGR+r0NTdEqjdwOthSGj24MFIkJsbUew=
=TujI
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at 29826 <at> debbugs.gnu.org:


Received: (at 29826) by debbugs.gnu.org; 23 Dec 2017 20:48:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 23 15:48:37 2017
Received: from localhost ([127.0.0.1]:49590 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eSqij-000326-46
	for submit <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:48:37 -0500
Received: from hera.aquilenet.fr ([141.255.128.1]:56106)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andreas@HIDDEN>) id 1eSqih-00031y-Ln
 for 29826 <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:48:35 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 67058FFC1;
 Sat, 23 Dec 2017 21:48:38 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id hT5FAy2p4xQK; Sat, 23 Dec 2017 21:48:37 +0100 (CET)
Received: from jurong (pD9570BD9.dip0.t-ipconnect.de [217.87.11.217])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 7DDB9EE7B;
 Sat, 23 Dec 2017 21:48:36 +0100 (CET)
Date: Sat, 23 Dec 2017 21:48:28 +0100
From: Andreas Enge <andreas@HIDDEN>
To: Alex Vong <alexvong1995@HIDDEN>
Subject: Re: bug#29826: nondeterministic Broken pipe
Message-ID: <20171223204828.GA3290@jurong>
References: <874lohdwhb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <874lohdwhb.fsf@HIDDEN>
User-Agent: Mutt/1.9.2 (2017-12-15)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 29826
Cc: 29826 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

On Sun, Dec 24, 2017 at 04:23:44AM +0800, Alex Vong wrote:
> ERROR: In procedure display:
> ERROR: In procedure scm_flush: Broken pipe

Interesting! I get a different error message:

ERROR: In procedure display:
In procedure fport_write: Broken pipe

Andreas





Information forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Dec 2017 20:24:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 23 15:24:16 2017
Received: from localhost ([127.0.0.1]:49578 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eSqL9-0002Sp-V6
	for submit <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:24:16 -0500
Received: from eggs.gnu.org ([208.118.235.92]:57319)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <alexvong1995@HIDDEN>) id 1eSqL7-0002Sb-F7
 for submit <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:24:14 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alexvong1995@HIDDEN>) id 1eSqL1-0006lV-33
 for submit <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:24:08 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.2 required=5.0 tests=BAYES_05,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:42077)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <alexvong1995@HIDDEN>)
 id 1eSqL0-0006kx-RV
 for submit <at> debbugs.gnu.org; Sat, 23 Dec 2017 15:24:06 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:48196)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <alexvong1995@HIDDEN>) id 1eSqKz-0002Y9-Ke
 for bug-guix@HIDDEN; Sat, 23 Dec 2017 15:24:06 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <alexvong1995@HIDDEN>) id 1eSqKw-0006gO-Rg
 for bug-guix@HIDDEN; Sat, 23 Dec 2017 15:24:05 -0500
Received: from mail-pl0-x232.google.com ([2607:f8b0:400e:c01::232]:40041)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <alexvong1995@HIDDEN>)
 id 1eSqKw-0006fD-IF
 for bug-guix@HIDDEN; Sat, 23 Dec 2017 15:24:02 -0500
Received: by mail-pl0-x232.google.com with SMTP id 62so13308436pld.7
 for <bug-guix@HIDDEN>; Sat, 23 Dec 2017 12:24:02 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:user-agent:mime-version;
 bh=Lfng+UCHmmzSdENL4nm0lY8TNT6DgVvT15YVJWkmJI4=;
 b=W2z81JDyItFwfvzaAP+3d8erh9Tom0mvxF/OHgorw+Dp2LI5Yf+6qg7JhRktg9kKG2
 pJk6sm+UrjKztIfcd912xqRcMlPxQTC8E29CIAcQ4Z7apo7LI3jfgJdb6cQftprBCq+m
 lS4fQgsupxq0V6mMCI0OWKb+pVSZNaKXo8Mn0xlsWAn+SxXjXribJrop5FAXX2rqW5fC
 T9YWMMYSpPknVzQXPFq23TBsolcq9A4xcwaJ5xYaOUqql+qQZjMBCp+fGiDiA9ZTpVvh
 N/Asc6nQusqsnA/ujMtvCRf5Q9FTUQ9zKsoB1+Lkt6eCX0Srl4tlXG3oBtlkw6OoncZV
 uBzw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:user-agent
 :mime-version;
 bh=Lfng+UCHmmzSdENL4nm0lY8TNT6DgVvT15YVJWkmJI4=;
 b=apPKm34UxoAQQ6NnHHySVO6LaY/dKRBmx+9AwBpxw3a47lZA7sKFIkkDZ2Haha4jij
 wIm0CTslkDNuDAX6A13oNKrvunuAFsX3uKUrF4oLrymhsi5cQ5YbtyxofwLjs7bavbb0
 LiFOEUJCfCWVyRINZ5wWFGYnsiPH0dzhqiZvvubuLdRFaw1zOrqnwBtZU0k0fbxb9hs1
 sJfgoCGgKdj0f4oUhb4WP+d21npzp5tQ8+MY3K68OiEc7hG4I32HQGaR/3NhJ91x8fsh
 tZtuGkFXemxSB1H/Qx64SvJxBv+QhMr+BLIhf2AQPZSqQIOKJeXm7R5FI3j5Qy+g1e9V
 mNvg==
X-Gm-Message-State: AKGB3mLD1H/V8NEjAUlwfHcWhdDtTXBH1FxpyLj5Otx3anSOh27r6xTW
 2J8B6SgtpNezeyd44303pUk=
X-Google-Smtp-Source: ACJfBotgWoi/UC87jmLmHq9NGqcVajZ2K505fZvvpJdugr6habnyArLVRIfBitp0jA2Dar3PGM7FuA==
X-Received: by 10.84.248.148 with SMTP id q20mr18593297pll.110.1514060641521; 
 Sat, 23 Dec 2017 12:24:01 -0800 (PST)
Received: from debian (1-64-81-074.static.netvigator.com. [1.64.81.74])
 by smtp.gmail.com with ESMTPSA id m9sm46138632pff.3.2017.12.23.12.23.59
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 23 Dec 2017 12:24:00 -0800 (PST)
From: Alex Vong <alexvong1995@HIDDEN>
To: bug-guix@HIDDEN
Subject: nondeterministic Broken pipe
Date: Sun, 24 Dec 2017 04:23:44 +0800
Message-ID: <874lohdwhb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)

--=-=-=
Content-Type: text/plain

Hello,

I get the following error when running ``guix --version | head -n 1''. I
can get similar after replacing ``--version'' with ``--help''. Also, the
error is nondeterministic. Any idea?


$ LC_ALL=C guix --version | head -n 1
guix (GNU Guix) 91213c384b62bc422896d39005efa922e4fa75f2
Backtrace:
In ice-9/boot-9.scm:
 160: 14 [catch #t #<catch-closure 5628460c6140> ...]
In unknown file:
   ?: 13 [apply-smob/1 #<catch-closure 5628460c6140>]
In ice-9/boot-9.scm:
  66: 12 [call-with-prompt prompt0 ...]
In ice-9/eval.scm:
 432: 11 [eval # #]
In ice-9/boot-9.scm:
2404: 10 [save-module-excursion #<procedure 5628460e8900 at ice-9/boot-9.scm:4051:3 ()>]
4056: 9 [#<procedure 5628460e8900 at ice-9/boot-9.scm:4051:3 ()>]
1727: 8 [%start-stack load-stack ...]
1732: 7 [#<procedure 5628460fdb40 ()>]
In unknown file:
   ?: 6 [primitive-load "/usr/local/bin/guix"]
In guix/ui.scm:
 390: 5 [show-version-and-exit "guix"]
In ice-9/format.scm:
1593: 4 [format #t "Copyright ~a 2017 ~a" "(C)" "the Guix authors\n"]
 766: 3 [format:format-work "Copyright ~a 2017 ~a" ("(C)" "the Guix authors\n")]
 264: 2 [tilde-dispatch]
  73: 1 [format:out-obj-padded #f "the Guix authors\n" #f ()]
In unknown file:
   ?: 0 [display "the Guix authors\n" #<output: file 1>]

ERROR: In procedure display:
ERROR: In procedure scm_flush: Broken pipe
Backtrace:
In ice-9/boot-9.scm:
 160: 1 [catch #t #<catch-closure 562846cd3020> ...]
In unknown file:
   ?: 0 [apply-smob/1 #<catch-closure 562846cd3020>]

ERROR: In procedure apply-smob/1:
ERROR: In procedure scm_flush: Broken pipe


Cheers,
Alex

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEdZDkzSn0Cycogr9IxYq4eRf1Ea4FAlo+u1EACgkQxYq4eRf1
Ea4WFQ//Qs7gaQ4IqFdRINQw7hXfgiFCimU6H0R5wVmY04KKDdvIJCcoQ4uJnZt0
cBriF97WqsTLJnqGWufbHZjdqg5QwkC94PAHGiGOMip8oiYx0LEMEFCyDasJpDBM
BxCInhYn0cc6S1lybm/MqCUg0LIJxsPGnX9omt0JBqyRK+uzR04UXH8D5WEt+ce3
9sJEfW1i4jItohH61O/84UC9s2M6xcwDdK00ccOI124HjY/L5o0Q78o62oKgriyR
I7LDV94SK3SFewv1HfmJp9cv1dcQ9P6PUj3xuvSoilynAqZYL0jRBJjIu0o2TNov
HtiOMn3GuxD1Gydndka9GVaoF7l77zrhekNZK1Yyx0S/ErNDtGrnjSpOcIZOhPN5
m7TWSPgySzQ6zG/rMV11TN0cw5u47ySQvpkAm87FwVjWjGQqkzcAWx4H4xrV8o/e
m+crN/IVsJXOgV44Kd9NRz4zU6qjDyS8bfdlKj5w7U34Lgiqk4r+Z9EkhWD4PWjO
cNftriGtKgRCI2io9yvKrUe+oBt5NmJi05uIq3jp6mR7JqoNRsi87cNYKgaPbG09
PILRGAXvqTD+zVH2L4tHVtfeajmosFZStKHXt6UVtXi9z62IHdIfw4h3CdlUU8tD
RAyFv8H8jDpQJoDV8ZPxyYn9jZuR9N4FTN/dzaqO+2p4UPnVIls=
=VWJk
-----END PGP SIGNATURE-----
--=-=-=--




Acknowledgement sent to Alex Vong <alexvong1995@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#29826; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 14 Feb 2018 12:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.